# Update the Redeemer Type

1. Add  `StarterRAction (..),` in the `Starter.Types` list of exported functions
2. Define a `StarterRAction` Data type with:
```
data StarterRAction = TrueF | FalseF | TrueS | FalseS
```
and its functionalities:
```
deriving    (Show, Generic, Pr.Eq, Pr.Ord, Pr.Read)
```

3. We'll be using the Redeemer in the form of an indexed data type, with:
```
PlutusTx.makeIsDataIndexed ''StarterRAction [('TrueF, 0), ('FalseF, 1) , ('TrueS, 2) , ('FalseS, 3)]
```

Notice how the index is mapped to the type parameters

<br />
---

## Your Task: Update the Validator function
1. Use a `case expression` to handle the flow (cases) of the validator with `case...action...of`
2. Assign each case `TrueF, FalseF, TrueS, FalseS` to its corresponding outcome or conditions
3. Prepare the redeemer files corresponding to the indexed parameters. Each file will have the form `{"constructor":{i},"fields":[]}` with `{i}` representing the index (from 0 to 3).
4. Depending on whether you have set an error message for debugging, check the error and make corrections
In our example, we tried the flow leading to a `False` result which caused an error and then used the file leading to the `True` outcome. Remember that you can set your own order and we used several files to show that each pair would have the same outcome, meaning that the flow is correct.
5. Follow the bonus lesson in the video, or play with redeemer forms of your own. As always, bring your questions to [Live Coding](/live-coding)!

import MDXLessonLayout from "@/src/components/lms/Lesson/MDXLessonLayout.tsx";
export default ({ children }) => <MDXLessonLayout>{children}</MDXLessonLayout>;